#include <iostream>
#include <boost/fiber/all.hpp>

int main()
{
	const int N = 2;

	boost::fibers::fiber threads[N];

	for (auto& t: threads)
		t = boost::fibers::fiber([]
		{
			while (true)
			{
				std::cout << "hola, soy "
				          << boost::this_fiber::get_id()
				          << std::endl;
				boost::this_fiber::yield();
			}
		});

	for (auto& t: threads)
		t.join();
}
